import java.lang.*;
import java.util.*;
import java.net.*;
import java.io.*;

public class clubData
{
  Vector regNames = new Vector(100);
  Vector memData  = new Vector(100);
  Vector regStatus = new Vector(4);
  private String sProto = "http";
  private String sHost;
  private String sDir;
  private String sCgix;
  private String sRc;
  private String sCgiIn;
  private int    iPort=2300;

  public clubData(String h, String dir, String cgix, int port) {
     sHost = h;
     sDir  = dir;
     sCgix = cgix;
     iPort = port;
  }

// method to import the club membership file for use.

  public Enumeration getAllMembers(){
        sCgiIn = "Action=getall";
        sRc = postData(sCgiIn, memData);
	return memData.elements();
   } 	 	 	 	 	 
 
		 
// method to register a specified name

  public String register(String name) {
       sCgiIn = "Action=register&members=" + name;
       sRc = postData(sCgiIn, regStatus);
       return (String) regStatus.elementAt(0);
  }

// method to register a guest for raffle

  public String registerGuest(String name) {
       sCgiIn = "Action=registerguest&members=" + name;
       sRc = postData(sCgiIn, regStatus);
       return (String) regStatus.elementAt(0);
  }

// method to add a new member and optionally register

  public String addMember(String name, boolean bRegister) {
       sCgiIn = "Action=addmember&members=" + name;
       sRc = postData(sCgiIn, regStatus);
       if (bRegister) {
          if (sRc.equals("0")) {
             sCgiIn = "Action=register&members=" + name;
             sRc = postData(sCgiIn, regStatus);
          }
       }
       return (String) regStatus.elementAt(0);
  }

// method to obtain all registered names

  public Enumeration getRegistered() {
       sCgiIn = "Action=getregistered";
       sRc = postData(sCgiIn, regNames);
       return regNames.elements();
  }

// method to flush data to output file

  public String commandData(String cmd) {
        sCgiIn = "Action=" + cmd;
        sRc = postData(sCgiIn, regStatus);
        return (String) regStatus.elementAt(0);
  }

// method to communicate with server at URL level

  private String postData(String req, Vector outs) {
    boolean bEof = true;
    String sLine, rc = "0";

    outs.removeAllElements();

    try {  	
       URL url = new URL(sProto, sHost, iPort, "/" + sDir + "/" + sCgix);
       URLConnection conn = url.openConnection();
       conn.setDoOutput(true);
       PrintStream ps = new PrintStream(conn.getOutputStream());
       ps.println(req);
       ps.close();
       DataInputStream dis = new DataInputStream(conn.getInputStream());
       bEof = false;
       while (!bEof) {
         try {
            if ( (sLine = dis.readLine()) != null) {
               if (sLine.startsWith("==")) {
                  sLine = sLine.substring(2);
                  if (outs.isEmpty()) {                //if first line
                    int iy = sLine.indexOf(":");
                    if (iy > -1) {
                       rc = sLine.substring(0, iy).trim();
                       sLine = sLine.substring(iy+1).trim();
                    }
                  }
                  outs.addElement(sLine);
               }
            }
            else
               bEof = true;
         } /* endtry */
         catch (NullPointerException ef) {
            bEof = true;
            dis.close();
         } /* endcatch */
       } /* endwhile */
    }
    catch ( Exception e ) {

    } /* endcatch */

    return rc;
  }    
}